/*
Copyright (c) 2004 EarthLink, Inc.
All rights reserved.

FPeer Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions 
are met:
1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. The name of the author may not be used to endorse or promote products
   derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/*
 * Created on Mar 29, 2004
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package net.earthlink.research.p2p;

import java.util.Iterator;
import java.util.Vector;

import org.apache.log4j.Logger;

/**
 * @author Mark Petrovic
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class Subscriptions extends Vector {

   Object lock = new Object();

   Vector pendingTable;   
   Logger logger;

   public Subscriptions() {
      logger = Logger.getLogger(this.getClass().getName());
      pendingTable = new Vector();
   }

   /**
    * 
    * @param subscription
    */
   public void add (Subscription subscription) {
      super.add(subscription);
      logger.warn("Subscription added = " + subscription.getHost());
      FPeer.fpeer.netherHosts.remove(subscription.getHost());
      FPeer.fpeer.updateWindowManager();
   }

   /**
    * 
    * @param address
    */
   public void remove (String address) {
      Subscription sub;
      Vector       v;  

      v = new Vector();
      for( Iterator i = iterator(); i.hasNext(); ) {
         sub = (Subscription )i.next();
         if ( sub.getHost().equals(address)) {
            v.add(sub);
         }
      }
      
      /* Remove the object outside "this" iterator to avoid
      java.util.ConcurrentModificationException */

      for( Iterator i = v.iterator(); i.hasNext(); ) {
         Subscription subscription;

         subscription = (Subscription )i.next();
         super.remove(subscription);
         FPeer.fpeer.netherHosts.add(subscription.getHost());
      }

      FPeer.fpeer.updateWindowManager();
      logger.warn("Subscription removed = " + address);
   }

   /**
    * 
    * @param address
    * @return
    */
   public boolean isSubscription(String address) {
      boolean      r;
      Subscription sub;

      r = false;
      for( Iterator i = iterator(); i.hasNext(); ) {
         sub = (Subscription )i.next();
         if( sub.getHost().equals(address) ) {
            r = true;
            break;
         }
      }
      return r;
   }
   
   boolean isPending(String host) {
      boolean r;
      String  h;

      r = false;
      for( Iterator i = pendingTable.iterator(); i.hasNext(); ) {
         h = (String )i.next();
         if( h.equals(host) ) {
            r = true;
            break;
         }
      }
      return r;
   }
   
   public void addPending(String host) {
      pendingTable.add(host);
   }
   
   public void removePending(String host) {
      boolean r;
      String  h;
      Vector  v;

      v = new Vector();
      r = false;
      for( Iterator i = pendingTable.iterator(); i.hasNext(); ) {
         h = (String )i.next();
         if( h.equals(host) ) {
            //pendingTable.remove(h);
            v.add(h);
            break;
         }
      }      

      for( Iterator i = v.iterator(); i.hasNext(); ) {
         pendingTable.remove(i.next());
      }      
   }
}
